// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_actions_msgs:action/LookAt.idl
// generated code does not contain a copyright notice
#include "hri_actions_msgs/action/detail/look_at__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `look_goal`
#include "geometry_msgs/msg/detail/point_stamped__functions.h"

bool
hri_actions_msgs__action__LookAt_Goal__init(hri_actions_msgs__action__LookAt_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // look_goal
  if (!geometry_msgs__msg__PointStamped__init(&msg->look_goal)) {
    hri_actions_msgs__action__LookAt_Goal__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_Goal__fini(hri_actions_msgs__action__LookAt_Goal * msg)
{
  if (!msg) {
    return;
  }
  // look_goal
  geometry_msgs__msg__PointStamped__fini(&msg->look_goal);
}

bool
hri_actions_msgs__action__LookAt_Goal__are_equal(const hri_actions_msgs__action__LookAt_Goal * lhs, const hri_actions_msgs__action__LookAt_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // look_goal
  if (!geometry_msgs__msg__PointStamped__are_equal(
      &(lhs->look_goal), &(rhs->look_goal)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Goal__copy(
  const hri_actions_msgs__action__LookAt_Goal * input,
  hri_actions_msgs__action__LookAt_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // look_goal
  if (!geometry_msgs__msg__PointStamped__copy(
      &(input->look_goal), &(output->look_goal)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_Goal *
hri_actions_msgs__action__LookAt_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Goal * msg = (hri_actions_msgs__action__LookAt_Goal *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_Goal));
  bool success = hri_actions_msgs__action__LookAt_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_Goal__destroy(hri_actions_msgs__action__LookAt_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_Goal__Sequence__init(hri_actions_msgs__action__LookAt_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Goal * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_Goal *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_Goal__Sequence__fini(hri_actions_msgs__action__LookAt_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_Goal__Sequence *
hri_actions_msgs__action__LookAt_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Goal__Sequence * array = (hri_actions_msgs__action__LookAt_Goal__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_Goal__Sequence__destroy(hri_actions_msgs__action__LookAt_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_Goal__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Goal__Sequence * lhs, const hri_actions_msgs__action__LookAt_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Goal__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Goal__Sequence * input,
  hri_actions_msgs__action__LookAt_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_Goal * data =
      (hri_actions_msgs__action__LookAt_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
hri_actions_msgs__action__LookAt_Result__init(hri_actions_msgs__action__LookAt_Result * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
hri_actions_msgs__action__LookAt_Result__fini(hri_actions_msgs__action__LookAt_Result * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
hri_actions_msgs__action__LookAt_Result__are_equal(const hri_actions_msgs__action__LookAt_Result * lhs, const hri_actions_msgs__action__LookAt_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Result__copy(
  const hri_actions_msgs__action__LookAt_Result * input,
  hri_actions_msgs__action__LookAt_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

hri_actions_msgs__action__LookAt_Result *
hri_actions_msgs__action__LookAt_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Result * msg = (hri_actions_msgs__action__LookAt_Result *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_Result));
  bool success = hri_actions_msgs__action__LookAt_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_Result__destroy(hri_actions_msgs__action__LookAt_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_Result__Sequence__init(hri_actions_msgs__action__LookAt_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Result * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_Result *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_Result__Sequence__fini(hri_actions_msgs__action__LookAt_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_Result__Sequence *
hri_actions_msgs__action__LookAt_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Result__Sequence * array = (hri_actions_msgs__action__LookAt_Result__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_Result__Sequence__destroy(hri_actions_msgs__action__LookAt_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_Result__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Result__Sequence * lhs, const hri_actions_msgs__action__LookAt_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Result__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Result__Sequence * input,
  hri_actions_msgs__action__LookAt_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_Result * data =
      (hri_actions_msgs__action__LookAt_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
hri_actions_msgs__action__LookAt_Feedback__init(hri_actions_msgs__action__LookAt_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
hri_actions_msgs__action__LookAt_Feedback__fini(hri_actions_msgs__action__LookAt_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
hri_actions_msgs__action__LookAt_Feedback__are_equal(const hri_actions_msgs__action__LookAt_Feedback * lhs, const hri_actions_msgs__action__LookAt_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Feedback__copy(
  const hri_actions_msgs__action__LookAt_Feedback * input,
  hri_actions_msgs__action__LookAt_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

hri_actions_msgs__action__LookAt_Feedback *
hri_actions_msgs__action__LookAt_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Feedback * msg = (hri_actions_msgs__action__LookAt_Feedback *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_Feedback));
  bool success = hri_actions_msgs__action__LookAt_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_Feedback__destroy(hri_actions_msgs__action__LookAt_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__init(hri_actions_msgs__action__LookAt_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Feedback * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_Feedback *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_Feedback__Sequence__fini(hri_actions_msgs__action__LookAt_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_Feedback__Sequence *
hri_actions_msgs__action__LookAt_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_Feedback__Sequence * array = (hri_actions_msgs__action__LookAt_Feedback__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_Feedback__Sequence__destroy(hri_actions_msgs__action__LookAt_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Feedback__Sequence * lhs, const hri_actions_msgs__action__LookAt_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Feedback__Sequence * input,
  hri_actions_msgs__action__LookAt_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_Feedback * data =
      (hri_actions_msgs__action__LookAt_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "hri_actions_msgs/action/detail/look_at__functions.h"

bool
hri_actions_msgs__action__LookAt_SendGoal_Request__init(hri_actions_msgs__action__LookAt_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    hri_actions_msgs__action__LookAt_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!hri_actions_msgs__action__LookAt_Goal__init(&msg->goal)) {
    hri_actions_msgs__action__LookAt_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Request__fini(hri_actions_msgs__action__LookAt_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  hri_actions_msgs__action__LookAt_Goal__fini(&msg->goal);
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Request__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Request * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!hri_actions_msgs__action__LookAt_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Request__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Request * input,
  hri_actions_msgs__action__LookAt_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!hri_actions_msgs__action__LookAt_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_SendGoal_Request *
hri_actions_msgs__action__LookAt_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Request * msg = (hri_actions_msgs__action__LookAt_SendGoal_Request *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_SendGoal_Request));
  bool success = hri_actions_msgs__action__LookAt_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Request__destroy(hri_actions_msgs__action__LookAt_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__init(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Request * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_SendGoal_Request *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__fini(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence *
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array = (hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__destroy(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * input,
  hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_SendGoal_Request * data =
      (hri_actions_msgs__action__LookAt_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
hri_actions_msgs__action__LookAt_SendGoal_Response__init(hri_actions_msgs__action__LookAt_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    hri_actions_msgs__action__LookAt_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Response__fini(hri_actions_msgs__action__LookAt_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Response__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Response * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Response__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Response * input,
  hri_actions_msgs__action__LookAt_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_SendGoal_Response *
hri_actions_msgs__action__LookAt_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Response * msg = (hri_actions_msgs__action__LookAt_SendGoal_Response *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_SendGoal_Response));
  bool success = hri_actions_msgs__action__LookAt_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Response__destroy(hri_actions_msgs__action__LookAt_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__init(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Response * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_SendGoal_Response *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__fini(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence *
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array = (hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__destroy(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * input,
  hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_SendGoal_Response * data =
      (hri_actions_msgs__action__LookAt_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
hri_actions_msgs__action__LookAt_GetResult_Request__init(hri_actions_msgs__action__LookAt_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    hri_actions_msgs__action__LookAt_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_GetResult_Request__fini(hri_actions_msgs__action__LookAt_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
hri_actions_msgs__action__LookAt_GetResult_Request__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Request * lhs, const hri_actions_msgs__action__LookAt_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_GetResult_Request__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Request * input,
  hri_actions_msgs__action__LookAt_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_GetResult_Request *
hri_actions_msgs__action__LookAt_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Request * msg = (hri_actions_msgs__action__LookAt_GetResult_Request *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_GetResult_Request));
  bool success = hri_actions_msgs__action__LookAt_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_GetResult_Request__destroy(hri_actions_msgs__action__LookAt_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__init(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Request * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_GetResult_Request *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__fini(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_GetResult_Request__Sequence *
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array = (hri_actions_msgs__action__LookAt_GetResult_Request__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__destroy(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * lhs, const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * input,
  hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_GetResult_Request * data =
      (hri_actions_msgs__action__LookAt_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "hri_actions_msgs/action/detail/look_at__functions.h"

bool
hri_actions_msgs__action__LookAt_GetResult_Response__init(hri_actions_msgs__action__LookAt_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!hri_actions_msgs__action__LookAt_Result__init(&msg->result)) {
    hri_actions_msgs__action__LookAt_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_GetResult_Response__fini(hri_actions_msgs__action__LookAt_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  hri_actions_msgs__action__LookAt_Result__fini(&msg->result);
}

bool
hri_actions_msgs__action__LookAt_GetResult_Response__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Response * lhs, const hri_actions_msgs__action__LookAt_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!hri_actions_msgs__action__LookAt_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_GetResult_Response__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Response * input,
  hri_actions_msgs__action__LookAt_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!hri_actions_msgs__action__LookAt_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_GetResult_Response *
hri_actions_msgs__action__LookAt_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Response * msg = (hri_actions_msgs__action__LookAt_GetResult_Response *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_GetResult_Response));
  bool success = hri_actions_msgs__action__LookAt_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_GetResult_Response__destroy(hri_actions_msgs__action__LookAt_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__init(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Response * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_GetResult_Response *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__fini(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_GetResult_Response__Sequence *
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array = (hri_actions_msgs__action__LookAt_GetResult_Response__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__destroy(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * lhs, const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * input,
  hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_GetResult_Response * data =
      (hri_actions_msgs__action__LookAt_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "hri_actions_msgs/action/detail/look_at__functions.h"

bool
hri_actions_msgs__action__LookAt_FeedbackMessage__init(hri_actions_msgs__action__LookAt_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    hri_actions_msgs__action__LookAt_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!hri_actions_msgs__action__LookAt_Feedback__init(&msg->feedback)) {
    hri_actions_msgs__action__LookAt_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__action__LookAt_FeedbackMessage__fini(hri_actions_msgs__action__LookAt_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  hri_actions_msgs__action__LookAt_Feedback__fini(&msg->feedback);
}

bool
hri_actions_msgs__action__LookAt_FeedbackMessage__are_equal(const hri_actions_msgs__action__LookAt_FeedbackMessage * lhs, const hri_actions_msgs__action__LookAt_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!hri_actions_msgs__action__LookAt_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_FeedbackMessage__copy(
  const hri_actions_msgs__action__LookAt_FeedbackMessage * input,
  hri_actions_msgs__action__LookAt_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!hri_actions_msgs__action__LookAt_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__action__LookAt_FeedbackMessage *
hri_actions_msgs__action__LookAt_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_FeedbackMessage * msg = (hri_actions_msgs__action__LookAt_FeedbackMessage *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__action__LookAt_FeedbackMessage));
  bool success = hri_actions_msgs__action__LookAt_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__action__LookAt_FeedbackMessage__destroy(hri_actions_msgs__action__LookAt_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__action__LookAt_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__init(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_FeedbackMessage * data = NULL;

  if (size) {
    data = (hri_actions_msgs__action__LookAt_FeedbackMessage *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__action__LookAt_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__action__LookAt_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__action__LookAt_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__fini(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__action__LookAt_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence *
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array = (hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__destroy(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__are_equal(const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * lhs, const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__copy(
  const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * input,
  hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__action__LookAt_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__action__LookAt_FeedbackMessage * data =
      (hri_actions_msgs__action__LookAt_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__action__LookAt_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__action__LookAt_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__action__LookAt_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
