// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_actions_msgs:action/LookAt.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__TRAITS_HPP_
#define HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_actions_msgs/action/detail/look_at__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'look_goal'
#include "geometry_msgs/msg/detail/point_stamped__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: look_goal
  {
    out << "look_goal: ";
    to_flow_style_yaml(msg.look_goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: look_goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "look_goal:\n";
    to_block_style_yaml(msg.look_goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_Goal & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_Goal>()
{
  return "hri_actions_msgs::action::LookAt_Goal";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_Goal>()
{
  return "hri_actions_msgs/action/LookAt_Goal";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_Goal>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PointStamped>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_Goal>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PointStamped>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_Result & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_Result & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_Result>()
{
  return "hri_actions_msgs::action::LookAt_Result";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_Result>()
{
  return "hri_actions_msgs/action/LookAt_Result";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_Result>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_Result>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_Feedback & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_Feedback & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_Feedback>()
{
  return "hri_actions_msgs::action::LookAt_Feedback";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_Feedback>()
{
  return "hri_actions_msgs/action/LookAt_Feedback";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "hri_actions_msgs/action/detail/look_at__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_SendGoal_Request & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_SendGoal_Request>()
{
  return "hri_actions_msgs::action::LookAt_SendGoal_Request";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_SendGoal_Request>()
{
  return "hri_actions_msgs/action/LookAt_SendGoal_Request";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<hri_actions_msgs::action::LookAt_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<hri_actions_msgs::action::LookAt_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_SendGoal_Response & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_SendGoal_Response>()
{
  return "hri_actions_msgs::action::LookAt_SendGoal_Response";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_SendGoal_Response>()
{
  return "hri_actions_msgs/action/LookAt_SendGoal_Response";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_SendGoal>()
{
  return "hri_actions_msgs::action::LookAt_SendGoal";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_SendGoal>()
{
  return "hri_actions_msgs/action/LookAt_SendGoal";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<hri_actions_msgs::action::LookAt_SendGoal_Request>::value &&
    has_fixed_size<hri_actions_msgs::action::LookAt_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<hri_actions_msgs::action::LookAt_SendGoal_Request>::value &&
    has_bounded_size<hri_actions_msgs::action::LookAt_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<hri_actions_msgs::action::LookAt_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<hri_actions_msgs::action::LookAt_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<hri_actions_msgs::action::LookAt_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_GetResult_Request & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_GetResult_Request>()
{
  return "hri_actions_msgs::action::LookAt_GetResult_Request";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_GetResult_Request>()
{
  return "hri_actions_msgs/action/LookAt_GetResult_Request";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "hri_actions_msgs/action/detail/look_at__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_GetResult_Response & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_GetResult_Response>()
{
  return "hri_actions_msgs::action::LookAt_GetResult_Response";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_GetResult_Response>()
{
  return "hri_actions_msgs/action/LookAt_GetResult_Response";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<hri_actions_msgs::action::LookAt_Result>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<hri_actions_msgs::action::LookAt_Result>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_GetResult>()
{
  return "hri_actions_msgs::action::LookAt_GetResult";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_GetResult>()
{
  return "hri_actions_msgs/action/LookAt_GetResult";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<hri_actions_msgs::action::LookAt_GetResult_Request>::value &&
    has_fixed_size<hri_actions_msgs::action::LookAt_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<hri_actions_msgs::action::LookAt_GetResult_Request>::value &&
    has_bounded_size<hri_actions_msgs::action::LookAt_GetResult_Response>::value
  >
{
};

template<>
struct is_service<hri_actions_msgs::action::LookAt_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<hri_actions_msgs::action::LookAt_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<hri_actions_msgs::action::LookAt_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "hri_actions_msgs/action/detail/look_at__traits.hpp"

namespace hri_actions_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const LookAt_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAt_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAt_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::action::LookAt_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::action::LookAt_FeedbackMessage & msg)
{
  return hri_actions_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::action::LookAt_FeedbackMessage>()
{
  return "hri_actions_msgs::action::LookAt_FeedbackMessage";
}

template<>
inline const char * name<hri_actions_msgs::action::LookAt_FeedbackMessage>()
{
  return "hri_actions_msgs/action/LookAt_FeedbackMessage";
}

template<>
struct has_fixed_size<hri_actions_msgs::action::LookAt_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<hri_actions_msgs::action::LookAt_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::action::LookAt_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<hri_actions_msgs::action::LookAt_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<hri_actions_msgs::action::LookAt_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<hri_actions_msgs::action::LookAt>
  : std::true_type
{
};

template<>
struct is_action_goal<hri_actions_msgs::action::LookAt_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<hri_actions_msgs::action::LookAt_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<hri_actions_msgs::action::LookAt_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__TRAITS_HPP_
