// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_actions_msgs:msg/ClosedCaption.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__TRAITS_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_actions_msgs/msg/detail/closed_caption__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace hri_actions_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClosedCaption & msg,
  std::ostream & out)
{
  out << "{";
  // member: speaker_id
  {
    out << "speaker_id: ";
    rosidl_generator_traits::value_to_yaml(msg.speaker_id, out);
    out << ", ";
  }

  // member: text
  {
    out << "text: ";
    rosidl_generator_traits::value_to_yaml(msg.text, out);
    out << ", ";
  }

  // member: locale
  {
    out << "locale: ";
    rosidl_generator_traits::value_to_yaml(msg.locale, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClosedCaption & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: speaker_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speaker_id: ";
    rosidl_generator_traits::value_to_yaml(msg.speaker_id, out);
    out << "\n";
  }

  // member: text
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "text: ";
    rosidl_generator_traits::value_to_yaml(msg.text, out);
    out << "\n";
  }

  // member: locale
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "locale: ";
    rosidl_generator_traits::value_to_yaml(msg.locale, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClosedCaption & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::msg::ClosedCaption & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::msg::ClosedCaption & msg)
{
  return hri_actions_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::msg::ClosedCaption>()
{
  return "hri_actions_msgs::msg::ClosedCaption";
}

template<>
inline const char * name<hri_actions_msgs::msg::ClosedCaption>()
{
  return "hri_actions_msgs/msg/ClosedCaption";
}

template<>
struct has_fixed_size<hri_actions_msgs::msg::ClosedCaption>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_actions_msgs::msg::ClosedCaption>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_actions_msgs::msg::ClosedCaption>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__TRAITS_HPP_
