// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_actions_msgs:msg/Intent.idl
// generated code does not contain a copyright notice
#include "hri_actions_msgs/msg/detail/intent__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `intent`
// Member `data`
// Member `source`
// Member `modality`
#include "rosidl_runtime_c/string_functions.h"

bool
hri_actions_msgs__msg__Intent__init(hri_actions_msgs__msg__Intent * msg)
{
  if (!msg) {
    return false;
  }
  // intent
  if (!rosidl_runtime_c__String__init(&msg->intent)) {
    hri_actions_msgs__msg__Intent__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__init(&msg->data)) {
    hri_actions_msgs__msg__Intent__fini(msg);
    return false;
  }
  // source
  if (!rosidl_runtime_c__String__init(&msg->source)) {
    hri_actions_msgs__msg__Intent__fini(msg);
    return false;
  }
  // modality
  if (!rosidl_runtime_c__String__init(&msg->modality)) {
    hri_actions_msgs__msg__Intent__fini(msg);
    return false;
  }
  // priority
  // confidence
  return true;
}

void
hri_actions_msgs__msg__Intent__fini(hri_actions_msgs__msg__Intent * msg)
{
  if (!msg) {
    return;
  }
  // intent
  rosidl_runtime_c__String__fini(&msg->intent);
  // data
  rosidl_runtime_c__String__fini(&msg->data);
  // source
  rosidl_runtime_c__String__fini(&msg->source);
  // modality
  rosidl_runtime_c__String__fini(&msg->modality);
  // priority
  // confidence
}

bool
hri_actions_msgs__msg__Intent__are_equal(const hri_actions_msgs__msg__Intent * lhs, const hri_actions_msgs__msg__Intent * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // intent
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->intent), &(rhs->intent)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  // source
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->source), &(rhs->source)))
  {
    return false;
  }
  // modality
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->modality), &(rhs->modality)))
  {
    return false;
  }
  // priority
  if (lhs->priority != rhs->priority) {
    return false;
  }
  // confidence
  if (lhs->confidence != rhs->confidence) {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__msg__Intent__copy(
  const hri_actions_msgs__msg__Intent * input,
  hri_actions_msgs__msg__Intent * output)
{
  if (!input || !output) {
    return false;
  }
  // intent
  if (!rosidl_runtime_c__String__copy(
      &(input->intent), &(output->intent)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  // source
  if (!rosidl_runtime_c__String__copy(
      &(input->source), &(output->source)))
  {
    return false;
  }
  // modality
  if (!rosidl_runtime_c__String__copy(
      &(input->modality), &(output->modality)))
  {
    return false;
  }
  // priority
  output->priority = input->priority;
  // confidence
  output->confidence = input->confidence;
  return true;
}

hri_actions_msgs__msg__Intent *
hri_actions_msgs__msg__Intent__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__Intent * msg = (hri_actions_msgs__msg__Intent *)allocator.allocate(sizeof(hri_actions_msgs__msg__Intent), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__msg__Intent));
  bool success = hri_actions_msgs__msg__Intent__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__msg__Intent__destroy(hri_actions_msgs__msg__Intent * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__msg__Intent__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__msg__Intent__Sequence__init(hri_actions_msgs__msg__Intent__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__Intent * data = NULL;

  if (size) {
    data = (hri_actions_msgs__msg__Intent *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__msg__Intent), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__msg__Intent__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__msg__Intent__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__msg__Intent__Sequence__fini(hri_actions_msgs__msg__Intent__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__msg__Intent__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__msg__Intent__Sequence *
hri_actions_msgs__msg__Intent__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__Intent__Sequence * array = (hri_actions_msgs__msg__Intent__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__msg__Intent__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__msg__Intent__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__msg__Intent__Sequence__destroy(hri_actions_msgs__msg__Intent__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__msg__Intent__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__msg__Intent__Sequence__are_equal(const hri_actions_msgs__msg__Intent__Sequence * lhs, const hri_actions_msgs__msg__Intent__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__msg__Intent__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__msg__Intent__Sequence__copy(
  const hri_actions_msgs__msg__Intent__Sequence * input,
  hri_actions_msgs__msg__Intent__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__msg__Intent);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__msg__Intent * data =
      (hri_actions_msgs__msg__Intent *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__msg__Intent__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__msg__Intent__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__msg__Intent__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
