// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_actions_msgs:msg/LookAtWithStyle.idl
// generated code does not contain a copyright notice
#include "hri_actions_msgs/msg/detail/look_at_with_style__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `target`
#include "geometry_msgs/msg/detail/point_stamped__functions.h"

bool
hri_actions_msgs__msg__LookAtWithStyle__init(hri_actions_msgs__msg__LookAtWithStyle * msg)
{
  if (!msg) {
    return false;
  }
  // style
  // target
  if (!geometry_msgs__msg__PointStamped__init(&msg->target)) {
    hri_actions_msgs__msg__LookAtWithStyle__fini(msg);
    return false;
  }
  return true;
}

void
hri_actions_msgs__msg__LookAtWithStyle__fini(hri_actions_msgs__msg__LookAtWithStyle * msg)
{
  if (!msg) {
    return;
  }
  // style
  // target
  geometry_msgs__msg__PointStamped__fini(&msg->target);
}

bool
hri_actions_msgs__msg__LookAtWithStyle__are_equal(const hri_actions_msgs__msg__LookAtWithStyle * lhs, const hri_actions_msgs__msg__LookAtWithStyle * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // style
  if (lhs->style != rhs->style) {
    return false;
  }
  // target
  if (!geometry_msgs__msg__PointStamped__are_equal(
      &(lhs->target), &(rhs->target)))
  {
    return false;
  }
  return true;
}

bool
hri_actions_msgs__msg__LookAtWithStyle__copy(
  const hri_actions_msgs__msg__LookAtWithStyle * input,
  hri_actions_msgs__msg__LookAtWithStyle * output)
{
  if (!input || !output) {
    return false;
  }
  // style
  output->style = input->style;
  // target
  if (!geometry_msgs__msg__PointStamped__copy(
      &(input->target), &(output->target)))
  {
    return false;
  }
  return true;
}

hri_actions_msgs__msg__LookAtWithStyle *
hri_actions_msgs__msg__LookAtWithStyle__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__LookAtWithStyle * msg = (hri_actions_msgs__msg__LookAtWithStyle *)allocator.allocate(sizeof(hri_actions_msgs__msg__LookAtWithStyle), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_actions_msgs__msg__LookAtWithStyle));
  bool success = hri_actions_msgs__msg__LookAtWithStyle__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_actions_msgs__msg__LookAtWithStyle__destroy(hri_actions_msgs__msg__LookAtWithStyle * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_actions_msgs__msg__LookAtWithStyle__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__init(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__LookAtWithStyle * data = NULL;

  if (size) {
    data = (hri_actions_msgs__msg__LookAtWithStyle *)allocator.zero_allocate(size, sizeof(hri_actions_msgs__msg__LookAtWithStyle), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_actions_msgs__msg__LookAtWithStyle__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_actions_msgs__msg__LookAtWithStyle__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_actions_msgs__msg__LookAtWithStyle__Sequence__fini(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_actions_msgs__msg__LookAtWithStyle__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_actions_msgs__msg__LookAtWithStyle__Sequence *
hri_actions_msgs__msg__LookAtWithStyle__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_actions_msgs__msg__LookAtWithStyle__Sequence * array = (hri_actions_msgs__msg__LookAtWithStyle__Sequence *)allocator.allocate(sizeof(hri_actions_msgs__msg__LookAtWithStyle__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_actions_msgs__msg__LookAtWithStyle__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_actions_msgs__msg__LookAtWithStyle__Sequence__destroy(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_actions_msgs__msg__LookAtWithStyle__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__are_equal(const hri_actions_msgs__msg__LookAtWithStyle__Sequence * lhs, const hri_actions_msgs__msg__LookAtWithStyle__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_actions_msgs__msg__LookAtWithStyle__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__copy(
  const hri_actions_msgs__msg__LookAtWithStyle__Sequence * input,
  hri_actions_msgs__msg__LookAtWithStyle__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_actions_msgs__msg__LookAtWithStyle);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_actions_msgs__msg__LookAtWithStyle * data =
      (hri_actions_msgs__msg__LookAtWithStyle *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_actions_msgs__msg__LookAtWithStyle__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_actions_msgs__msg__LookAtWithStyle__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_actions_msgs__msg__LookAtWithStyle__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
