// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from hri_actions_msgs:msg/LookAtWithStyle.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__FUNCTIONS_H_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "hri_actions_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "hri_actions_msgs/msg/detail/look_at_with_style__struct.h"

/// Initialize msg/LookAtWithStyle message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__msg__LookAtWithStyle
 * )) before or use
 * hri_actions_msgs__msg__LookAtWithStyle__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__init(hri_actions_msgs__msg__LookAtWithStyle * msg);

/// Finalize msg/LookAtWithStyle message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__msg__LookAtWithStyle__fini(hri_actions_msgs__msg__LookAtWithStyle * msg);

/// Create msg/LookAtWithStyle message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__msg__LookAtWithStyle__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__msg__LookAtWithStyle *
hri_actions_msgs__msg__LookAtWithStyle__create();

/// Destroy msg/LookAtWithStyle message.
/**
 * It calls
 * hri_actions_msgs__msg__LookAtWithStyle__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__msg__LookAtWithStyle__destroy(hri_actions_msgs__msg__LookAtWithStyle * msg);

/// Check for msg/LookAtWithStyle message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__are_equal(const hri_actions_msgs__msg__LookAtWithStyle * lhs, const hri_actions_msgs__msg__LookAtWithStyle * rhs);

/// Copy a msg/LookAtWithStyle message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__copy(
  const hri_actions_msgs__msg__LookAtWithStyle * input,
  hri_actions_msgs__msg__LookAtWithStyle * output);

/// Initialize array of msg/LookAtWithStyle messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__msg__LookAtWithStyle__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__init(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array, size_t size);

/// Finalize array of msg/LookAtWithStyle messages.
/**
 * It calls
 * hri_actions_msgs__msg__LookAtWithStyle__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__msg__LookAtWithStyle__Sequence__fini(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array);

/// Create array of msg/LookAtWithStyle messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__msg__LookAtWithStyle__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__msg__LookAtWithStyle__Sequence *
hri_actions_msgs__msg__LookAtWithStyle__Sequence__create(size_t size);

/// Destroy array of msg/LookAtWithStyle messages.
/**
 * It calls
 * hri_actions_msgs__msg__LookAtWithStyle__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__msg__LookAtWithStyle__Sequence__destroy(hri_actions_msgs__msg__LookAtWithStyle__Sequence * array);

/// Check for msg/LookAtWithStyle message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__are_equal(const hri_actions_msgs__msg__LookAtWithStyle__Sequence * lhs, const hri_actions_msgs__msg__LookAtWithStyle__Sequence * rhs);

/// Copy an array of msg/LookAtWithStyle messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__msg__LookAtWithStyle__Sequence__copy(
  const hri_actions_msgs__msg__LookAtWithStyle__Sequence * input,
  hri_actions_msgs__msg__LookAtWithStyle__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__FUNCTIONS_H_
