// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_actions_msgs:msg/LookAtWithStyle.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_H_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DEFAULT'.
/**
  * default policy: both eyes and head joints (eg neck) are used, the resulting
  * 'style' is a smooth combination of both
 */
enum
{
  hri_actions_msgs__msg__LookAtWithStyle__DEFAULT = 0
};

/// Constant 'EYES_ONLY'.
/**
  * eyes-only policy: only the eyes (if available) should move
 */
enum
{
  hri_actions_msgs__msg__LookAtWithStyle__EYES_ONLY = 1
};

/// Constant 'HEAD_ONLY'.
/**
  * head-only policy: only the head joints (typically, the neck) should move
 */
enum
{
  hri_actions_msgs__msg__LookAtWithStyle__HEAD_ONLY = 2
};

// Include directives for member types
// Member 'target'
#include "geometry_msgs/msg/detail/point_stamped__struct.h"

/// Struct defined in msg/LookAtWithStyle in the package hri_actions_msgs.
/**
  * Specify the target of the robot's gaze as a 3D point. A desired 'style'
  * policy can be specified to control how the gaze motion should be executed
  * (for instance, sudden movement, slow shift, etc.)
 */
typedef struct hri_actions_msgs__msg__LookAtWithStyle
{
  int8_t style;
  geometry_msgs__msg__PointStamped target;
} hri_actions_msgs__msg__LookAtWithStyle;

// Struct for a sequence of hri_actions_msgs__msg__LookAtWithStyle.
typedef struct hri_actions_msgs__msg__LookAtWithStyle__Sequence
{
  hri_actions_msgs__msg__LookAtWithStyle * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__msg__LookAtWithStyle__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_H_
