// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_actions_msgs:action/ApplicationControl.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__ACTION__DETAIL__APPLICATION_CONTROL__STRUCT_H_
#define HRI_ACTIONS_MSGS__ACTION__DETAIL__APPLICATION_CONTROL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'parameters'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_Goal
{
  rosidl_runtime_c__String parameters;
} hri_actions_msgs__action__ApplicationControl_Goal;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_Goal.
typedef struct hri_actions_msgs__action__ApplicationControl_Goal__Sequence
{
  hri_actions_msgs__action__ApplicationControl_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_Result
{
  uint8_t structure_needs_at_least_one_member;
} hri_actions_msgs__action__ApplicationControl_Result;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_Result.
typedef struct hri_actions_msgs__action__ApplicationControl_Result__Sequence
{
  hri_actions_msgs__action__ApplicationControl_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_Result__Sequence;


// Constants defined in the message

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_Feedback
{
  uint8_t structure_needs_at_least_one_member;
} hri_actions_msgs__action__ApplicationControl_Feedback;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_Feedback.
typedef struct hri_actions_msgs__action__ApplicationControl_Feedback__Sequence
{
  hri_actions_msgs__action__ApplicationControl_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "hri_actions_msgs/action/detail/application_control__struct.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  hri_actions_msgs__action__ApplicationControl_Goal goal;
} hri_actions_msgs__action__ApplicationControl_SendGoal_Request;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_SendGoal_Request.
typedef struct hri_actions_msgs__action__ApplicationControl_SendGoal_Request__Sequence
{
  hri_actions_msgs__action__ApplicationControl_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} hri_actions_msgs__action__ApplicationControl_SendGoal_Response;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_SendGoal_Response.
typedef struct hri_actions_msgs__action__ApplicationControl_SendGoal_Response__Sequence
{
  hri_actions_msgs__action__ApplicationControl_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} hri_actions_msgs__action__ApplicationControl_GetResult_Request;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_GetResult_Request.
typedef struct hri_actions_msgs__action__ApplicationControl_GetResult_Request__Sequence
{
  hri_actions_msgs__action__ApplicationControl_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "hri_actions_msgs/action/detail/application_control__struct.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_GetResult_Response
{
  int8_t status;
  hri_actions_msgs__action__ApplicationControl_Result result;
} hri_actions_msgs__action__ApplicationControl_GetResult_Response;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_GetResult_Response.
typedef struct hri_actions_msgs__action__ApplicationControl_GetResult_Response__Sequence
{
  hri_actions_msgs__action__ApplicationControl_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "hri_actions_msgs/action/detail/application_control__struct.h"

/// Struct defined in action/ApplicationControl in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__ApplicationControl_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  hri_actions_msgs__action__ApplicationControl_Feedback feedback;
} hri_actions_msgs__action__ApplicationControl_FeedbackMessage;

// Struct for a sequence of hri_actions_msgs__action__ApplicationControl_FeedbackMessage.
typedef struct hri_actions_msgs__action__ApplicationControl_FeedbackMessage__Sequence
{
  hri_actions_msgs__action__ApplicationControl_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__ApplicationControl_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__ACTION__DETAIL__APPLICATION_CONTROL__STRUCT_H_
