// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_actions_msgs:msg/ClosedCaption.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__msg__ClosedCaption __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__msg__ClosedCaption __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClosedCaption_
{
  using Type = ClosedCaption_<ContainerAllocator>;

  explicit ClosedCaption_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speaker_id = "";
      this->text = "";
      this->locale = "";
    }
  }

  explicit ClosedCaption_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : speaker_id(_alloc),
    text(_alloc),
    locale(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speaker_id = "";
      this->text = "";
      this->locale = "";
    }
  }

  // field types and members
  using _speaker_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _speaker_id_type speaker_id;
  using _text_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _text_type text;
  using _locale_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _locale_type locale;

  // setters for named parameter idiom
  Type & set__speaker_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->speaker_id = _arg;
    return *this;
  }
  Type & set__text(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->text = _arg;
    return *this;
  }
  Type & set__locale(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->locale = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SPEAKER_ID_SYSTEM;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SPEAKER_ID_UNKNOWN;

  // pointer types
  using RawPtr =
    hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__msg__ClosedCaption
    std::shared_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__msg__ClosedCaption
    std::shared_ptr<hri_actions_msgs::msg::ClosedCaption_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClosedCaption_ & other) const
  {
    if (this->speaker_id != other.speaker_id) {
      return false;
    }
    if (this->text != other.text) {
      return false;
    }
    if (this->locale != other.locale) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClosedCaption_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClosedCaption_

// alias to use template instance with default allocator
using ClosedCaption =
  hri_actions_msgs::msg::ClosedCaption_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
ClosedCaption_<ContainerAllocator>::SPEAKER_ID_SYSTEM = "__system__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
ClosedCaption_<ContainerAllocator>::SPEAKER_ID_UNKNOWN = "__unknown__";

}  // namespace msg

}  // namespace hri_actions_msgs

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_HPP_
