// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_actions_msgs:msg/LookAtWithStyle.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__TRAITS_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_actions_msgs/msg/detail/look_at_with_style__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'target'
#include "geometry_msgs/msg/detail/point_stamped__traits.hpp"

namespace hri_actions_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LookAtWithStyle & msg,
  std::ostream & out)
{
  out << "{";
  // member: style
  {
    out << "style: ";
    rosidl_generator_traits::value_to_yaml(msg.style, out);
    out << ", ";
  }

  // member: target
  {
    out << "target: ";
    to_flow_style_yaml(msg.target, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LookAtWithStyle & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: style
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "style: ";
    rosidl_generator_traits::value_to_yaml(msg.style, out);
    out << "\n";
  }

  // member: target
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target:\n";
    to_block_style_yaml(msg.target, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LookAtWithStyle & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::msg::LookAtWithStyle & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::msg::LookAtWithStyle & msg)
{
  return hri_actions_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::msg::LookAtWithStyle>()
{
  return "hri_actions_msgs::msg::LookAtWithStyle";
}

template<>
inline const char * name<hri_actions_msgs::msg::LookAtWithStyle>()
{
  return "hri_actions_msgs/msg/LookAtWithStyle";
}

template<>
struct has_fixed_size<hri_actions_msgs::msg::LookAtWithStyle>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PointStamped>::value> {};

template<>
struct has_bounded_size<hri_actions_msgs::msg::LookAtWithStyle>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PointStamped>::value> {};

template<>
struct is_message<hri_actions_msgs::msg::LookAtWithStyle>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__TRAITS_HPP_
